unit FireWater;

interface

Uses Globals;

procedure drawFire;
procedure initFire;
procedure CreateTimerRipple;
procedure DrawWater;

implementation

Uses dglOpenGL;
var firstRun : boolean = true;

procedure initFire();
var I, J : integer;
begin


  Viscosity :=0.99;
  For I :=0 to GRID_SIZE do
  begin
    For J :=0 to GRID_SIZE do
    begin
      Position[I, J] :=0;
      Velocity[I, J] :=0;
    end;
  end;
  CreateTimerRipple;
  CreateTimerRipple;
  CreateTimerRipple;
  CreateTimerRipple;
  {//create some fog
  FogDensity :=0.02;
  glFogi(GL_FOG_MODE, GL_EXP);
  glFogf(GL_FOG_DENSITY,FogDensity);
  glFogfv(GL_FOG_COLOR, @FogColor);
  glEnable(GL_FOG);}
end;

procedure drawFire();
var DemoTime , i : integer;
    C : glFloat;
begin
  DemoTime :=ElapsedTime - FIREWATER_START;
  
  if firstRun then
  begin
    glEnable(GL_TEXTURE_GEN_S);
    glEnable(GL_TEXTURE_GEN_T);
    glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
    glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
    //alpha stuff
    //glEnable(GL_ALPHA_TEST);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glAlphaFunc(GL_GREATER, 0.9);
    firstRun := false;
  end;

  // Fade the sequence in
  if DemoTime < 100 then
  begin
    glEnable(GL_BLEND);
    C :=1-DemoTime/100;
    glColor3f(C, C, C);

    glBindTexture(GL_TEXTURE_2D, WhiteTex);
    glBegin(GL_QUADS);
      glTexCoord2f(0, 0);  glVertex3f(-1, -1, -1.8);
      glTexCoord2f(1, 0);  glVertex3f( 1, -1, -1.8);
      glTexCoord2f(1, 1);  glVertex3f( 1,  1, -1.8);
      glTexCoord2f(0, 1);  glVertex3f(-1,  1, -1.8);
    glEnd;
    glDisable(GL_BLEND);
  end;

      
  if DemoTime mod 16 = 0 then
    CreateTimerRipple;

  // Fade the sequence out
  if ElapsedTime > METABALL_START - 800 then
  begin
    C := (METABALL_START - ElapsedTime) / 800;
    glTranslatef(0.0,0.0,-2);
    glDisable(GL_TEXTURE_2D);
    glDisable(GL_BLEND);
    glEnable(GL_DEPTH_TEST);
    glColor3f(0, 0, 0);
    glBegin(GL_QUADS);
      glVertex3f(C  ,-1.2, 0);
      glVertex3f(C  , 1.2, 0);
      glVertex3f(C+1, 1.2, 0);
      glVertex3f(C+1,-1.2, 0);

      glVertex3f(-1-C ,-1.2, 0);
      glVertex3f(-1-C , 1.2, 0);
      glVertex3f(  -C , 1.2, 0);
      glVertex3f(  -C ,-1.2, 0);
    glEnd();
    glColor3f(1, 1, 1);
    glEnable(GL_TEXTURE_2D);
  end;

  glColor3f(0.5, 0.5, 0.5);

  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_NORMALIZE);

  glTranslatef(0.0,0.0,-2.0);

  glPushMatrix;
    glRotatef(45,1.0,0.0,0.0);
    glTranslatef(0.0,-0.4,-1.0);
    glScalef(1.0,1.0,1.0);
    //glDisable(GL_TEXTURE_2D);
    DrawWater;
    //glEnable(GL_TEXTURE_2D);
  glPopMatrix;

  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_NORMALIZE);


  // Draw main flames
  glEnable(GL_BLEND);
  glPushMatrix;
    glRotatef(-45,1.0,0.0,0.0);
    glColor3f(1.0, 1.0, 1.0);
    glBindTexture(GL_TEXTURE_2D, MovingFire[g_CurrentFire] );
    glBegin(GL_QUADS);
        glTexCoord2f(0, 0);  glVertex3f(-2, -2, 0.0);
        glTexCoord2f(1, 0);  glVertex3f( 2, -2, 0.0);
        glTexCoord2f(1, 1);  glVertex3f( 2,  2, 0.0);
        glTexCoord2f(0, 1);  glVertex3f(-2,  2, 0.0);
    glEnd;
  glPopMatrix;

  // Draw Radial Flames
  if ElapsedTime > METABALL_START - 3000 then
  begin
      glEnable(GL_ALPHA_TEST);
      for i := 1 to 4 do
      begin
        glPushMatrix;
          glEnable(GL_BLEND);
          glRotatef(-45,1.0,0.0,0.0);
          glTranslatef(1.0/i,0.0,0.001*i);
          glColor3f(1.0/i, 0.0, 0.0);
          glBindTexture(GL_TEXTURE_2D, MovingFire[g_CurrentFire] );
          glBegin(GL_QUADS);
              glTexCoord2f(0, 0);  glVertex3f(-2, -2, 0.0);
              glTexCoord2f(1, 0);  glVertex3f( 2, -2, 0.0);
              glTexCoord2f(1, 1);  glVertex3f( 2,  2, 0.0);
              glTexCoord2f(0, 1);  glVertex3f(-2,  2, 0.0);
          glEnd;
        glPopMatrix;
      end;
      for i := 4 downto 1 do
      begin
        glPushMatrix;
          glEnable(GL_BLEND);
          glRotatef(-45,1.0,0.0,0.0);
          glTranslatef(-(1.0/i),0.0,0.01*i);
          glColor3f(1.0/i, 0.0, 0.0);
          glBindTexture(GL_TEXTURE_2D, MovingFire[g_CurrentFire] );
          glBegin(GL_QUADS);
              glTexCoord2f(0, 0);  glVertex3f(-2, -2, 0.0);
              glTexCoord2f(1, 0);  glVertex3f( 2, -2, 0.0);
              glTexCoord2f(1, 1);  glVertex3f( 2,  2, 0.0);
              glTexCoord2f(0, 1);  glVertex3f(-2,  2, 0.0);
          glEnd;
        glPopMatrix;
      end;
      glDisable(GL_ALPHA_TEST);
  end;
  glDisable(GL_BLEND);
  if ElapsedTime > METABALL_START then
  begin
    glDisable(GL_ALPHA_TEST);
    Inc(Stage);
  end;
end;

procedure CreateTimerRipple;
begin
  Velocity[random(GRID_SIZE-3)+2, random(GRID_SIZE-3)+2] := 1060;
end;

procedure DrawWater;
var I, J : Integer;
    VectLength : glFloat;
begin
  // Calculate new velocity
  For I :=2 to GRID_SIZE-2 do
    For J :=2 to GRID_SIZE-2 do
      Velocity[I, J] := Velocity[I, J] + (Position[I, J] -
              (4*(Position[I-1,J] + Position[I+1,J] + Position[I,J-1] + Position[I,J+1]) +  // left, right, above, below
              Position[I-1,J-1] + Position[I+1,J-1] + Position[I-1,J+1] + Position[I+1,J+1])/25) / 7;  // diagonally across

  // Calculate the new ripple positions
  For I:=2 to GRID_SIZE-2 do
    For J:=2 to GRID_SIZE-2 do
    Begin
      Position[I, J] := Position[I, J] - Velocity[I,J];
      Velocity[I, J] := Velocity[I, J] * Viscosity;
    End;

  // Calculate the new vertex coordinates
  For I :=0 to GRID_SIZE do
    For J :=0 to GRID_SIZE do
    begin
      Vertex[I, J].X :=(I - GRID_SIZE/2)/GRID_SIZE*5;
      Vertex[I, J].Y :=(Position[I, J] / 1024)/GRID_SIZE*3;
      Vertex[I, J].Z :=(J - GRID_SIZE/2)/GRID_SIZE*5;
    end;

  // Calculate the new vertex normals.
  // Do this by using the points to each side to get the right angle
  For I :=0 to GRID_SIZE do
  begin
    For J :=0 to GRID_SIZE do
    begin
      If (I > 0) and (J > 0) and (I < GRID_SIZE) and (J < GRID_SIZE) then
      begin
        with Normals[I, J] do
        begin
          X := Position[I+1, J] - Position[I-1,J];
          Y := -2048;
          Z := Position[I, J+1] - Position[I, J-1];

          VectLength :=sqrt(x*x + y*y + z*z);
          if VectLength <> 0 then
          begin
            X :=X/VectLength;
            Y :=Y/VectLength;
            Z :=Z/VectLength;
          end;
        end;
      end
      else
      begin
        Normals[I, J].X :=0;
        Normals[I, J].Y :=1;
        Normals[I, J].Z :=0;
      end;
    end;
  end;

  // Draw the water texture
  glBindTexture(GL_TEXTURE_2D, WaterTex);

  //glMaterialfv(GL_FRONT, GL_SPECULAR,@SpecularReflect);
  //glMateriali(GL_FRONT, GL_SHININESS,128);
  //glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE,@AmbDiffReflect);

  For J :=0 to GRID_SIZE-1 do
  begin
    glBegin(GL_QUAD_STRIP);
      for I :=0 to GRID_SIZE do
      begin
        glColor3f(1.0,1.0,1.0);
        glNormal3fv(@Normals[I, J+1]);
        glTexCoord2f(I/GRID_SIZE, (J+1)/GRID_SIZE);
        glVertex3fv(@Vertex[I, J+1]);
        glNormal3fv(@Normals[I, J]);
        glTexCoord2f(I/GRID_SIZE, J/GRID_SIZE);
        glVertex3fv(@Vertex[I, J]);
      end;
    glEnd;
  end;
end;


end.
