unit Outtro;

interface

Uses Globals;

  procedure drawOuttro;

implementation

Uses dglOpenGL;

type TVertex = Record
       X, Y, Z : glFloat;
     end;
var DemoTime : Integer;
    LazerPosition : integer = 1;
    LazerSize : GLfloat = 0.05;
    LogoColor : GLfloat = 0.0;
    MysticSoundColor : GLfloat = 0.0;
    BlueSpillColor : GLfloat = 0.0;
    SulacoColor : GLfloat = 0.0;
    CDColor : GLfloat = 0.0;
    g_SinAngle : GLfloat = 0.0;

{------------------------------------------------------------------}
{  Draw the Outtro scene                                           }
{------------------------------------------------------------------}
procedure drawOuttro;
var I : Integer;
    X : glFloat;
begin
  DemoTime :=ElapsedTime - TENTACLE_START;

  // Draw the Ocean background
  glDisable(GL_DEPTH_TEST);
  glPushMatrix();
    glTranslatef(0, 0, -2.7);
    glColor3f(1.0,1.0,1.0);
    glActiveTextureARB(GL_TEXTURE1_ARB);
    glDisable(GL_TEXTURE_2D);
    glActiveTextureARB(GL_TEXTURE0_ARB);
    glBindTexture(GL_TEXTURE_2D, Ocean);  // Bind the Texture to the object
    glBegin(GL_QUADS);
      glTexCoord2f(0, 0); glVertex3f(-1.0, -1.0, 0.0);
      glTexCoord2f(1, 0); glVertex3f( 1.0, -1.0, 0.0);
      glTexCoord2f(1, 1); glVertex3f( 1.0,  1.0, 0.0);
      glTexCoord2f(0, 1); glVertex3f(-1.0,  1.0, 0.0);
    glEnd();
  glPopMatrix();
 

  // Draw particles
  if DemoTime < 15001 then
  begin
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);

    glBindTexture(GL_TEXTURE_2D, BmpParticle);

    for I := 1 to LazerPosition do
    begin
      glColor3f(1.0/LazerPosition * I,1.0/LazerPosition * I,0.0);
      glPushMatrix;
        glTranslatef(vLazer[I].X,vLazer[I].Y,vLazer[I].Z-4.4);
        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
          glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
          glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
        glEnd();
      glPopMatrix;

      glPushMatrix;
        glTranslatef(vLazer[I].X * -1,vLazer[I].Y,vLazer[I].Z-4.4);
        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
          glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
          glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
        glEnd();
      glPopMatrix;
    end;

    LazerPosition := LazerPosition + 1;

    if LazerPosition > high(vLazer)-1 then
      LazerPosition := 1;

  end;

  // Draw Growing Particles
  if (DemoTime > 15000) and (DemoTime < 15501) then
  begin
    glBindTexture(GL_TEXTURE_2D, BmpParticle);

    for I := 1 to round(length(vLazer)/2)-1 do
    begin
      glPushMatrix;
        glColor3f(1.0/LazerPosition * I,1.0/LazerPosition * I,0.0);

        glTranslatef(vLazer[I].X,vLazer[I].Y,vLazer[I].Z-4.4);
        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-LazerSize, -LazerSize, 0.0);
          glTexCoord2f(1, 0); glVertex3f( LazerSize, -LazerSize, 0.0);
          glTexCoord2f(1, 1); glVertex3f( LazerSize,  LazerSize, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-LazerSize,  LazerSize, 0.0);
        glEnd();
       glPopMatrix;

       glPushMatrix;
        //glColor3f(1.0/LazerPosition * I,1.0/LazerPosition * I,0.0);
        glTranslatef(vLazer[I].X * -1,vLazer[I].Y,vLazer[I].Z-4.4);
        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-LazerSize, -LazerSize, 0.0);
          glTexCoord2f(1, 0); glVertex3f( LazerSize, -LazerSize, 0.0);
          glTexCoord2f(1, 1); glVertex3f( LazerSize,  LazerSize, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-LazerSize,  LazerSize, 0.0);
        glEnd();

       glPopMatrix;
    end;
    LazerSize := LazerSize + 0.05;
  end;

    // Draw Blue Particles
    if DemoTime > 15500 then
    begin
      glEnable(GL_TEXTURE_2D);
      glEnable(GL_BLEND);

      glBindTexture(GL_TEXTURE_2D, BmpParticle);
      glColor3f(0.0,0.0,1.0);
      for I := 1 to round(length(vLazer)/2)-1 do
      begin
        glPushMatrix;
          glTranslatef(vLazer[I].X + sin(I/360 * LazerPosition)/10,vLazer[I].Y -1,vLazer[I].Z-6.4);
          glBegin(GL_QUADS);
            glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
            glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
            glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
            glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
          glEnd();
        glPopMatrix;

        glPushMatrix;
          glTranslatef((vLazer[I].X + sin(I/360 * LazerPosition)/10) * -1,vLazer[I].Y -1,vLazer[I].Z-6.4);
          glBegin(GL_QUADS);
            glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
            glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
            glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
            glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
          glEnd();
        glPopMatrix;
      end;

      LazerPosition := LazerPosition + 1;
    end;


    if DemoTime > 26000 then
    begin
      glEnable(GL_TEXTURE_2D);
      glEnable(GL_BLEND);

      glBindTexture(GL_TEXTURE_2D, BmpParticle);
      glColor3f(0.0,MysticSoundColor,MysticSoundColor);

      for I := 1 to round(length(vLazer)/2)-1 do
      begin
        glPushMatrix;
          glTranslatef(vLazer[I].X + cos(I/360 * LazerPosition)/10,vLazer[I].Y -1,vLazer[I].Z-6.4);
          glBegin(GL_QUADS);
            glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
            glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
            glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
            glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
          glEnd();
        glPopMatrix;

        glPushMatrix;
          glTranslatef((vLazer[I].X + cos(I/360 * LazerPosition)/10) * -1,vLazer[I].Y -1,vLazer[I].Z-6.4);
          glBegin(GL_QUADS);
            glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
            glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
            glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
            glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
          glEnd();
        glPopMatrix;
      end;

    end;

    if DemoTime > 36000 then
    begin
      glEnable(GL_TEXTURE_2D);
      glEnable(GL_BLEND);

      glBindTexture(GL_TEXTURE_2D, BmpParticle);
      glColor3f(BlueSpillColor,0.0,0.0);

      for I := 1 to round(length(vLazer)/2)-1 do
      begin
        glPushMatrix;
          glTranslatef(vLazer[I].X + sin(I/360 * LazerPosition)/10,vLazer[I].Y -1 + cos(I/360 * LazerPosition)/10,vLazer[I].Z-6.4);
          glBegin(GL_QUADS);
            glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
            glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
            glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
            glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
          glEnd();
        glPopMatrix;

        glPushMatrix;
          glTranslatef((vLazer[I].X + sin(I/360 * LazerPosition)/10) * -1,vLazer[I].Y -1 + cos(I/360 * LazerPosition)/10,vLazer[I].Z-6.4);
          glBegin(GL_QUADS);
            glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
            glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
            glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
            glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
          glEnd();
        glPopMatrix;
      end;

    end;

    // Draw Volition Logo

    glPushMatrix;
      glColor3f(LogoColor,1.0,LogoColor);
      LogoColor := LogoColor + 0.001;

      glDisable(GL_BLEND);
      glEnable(GL_DEPTH_TEST);
      glTranslatef(0.0,0.0,-4.4);
      glRotatef(g_RotLogo,0.0,1.0,0.0);
      glRotatef(-90,1.0,0.0,0.0);
      g_VolitionLogo.render;

      glEnable(GL_DEPTH_TEST);
      glEnable(GL_BLEND);
      g_RotLogo := g_RotLogo + 0.2;
    glPopMatrix;


  //Draw Mystic Sound Logo
  if (DemoTime > 26000) then
  begin
    glActiveTextureARB(GL_TEXTURE1_ARB);
    glEnable(GL_TEXTURE_2D);
    glActiveTextureARB(GL_TEXTURE0_ARB);
    glEnable(GL_TEXTURE_2D);
    glColor3f(MysticSoundColor,MysticSoundColor,MysticSoundColor);
    MysticSoundColor := MysticSoundColor + 0.01;
    glPushMatrix;
      glTranslatef(-1.0,1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, BroughtBy);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;


  //Draw BluesSpill Logo
  if (DemoTime > 36000) then
  begin
    glColor3f(BlueSpillColor,BlueSpillColor,BlueSpillColor);
    BlueSpillColor := BlueSpillColor + 0.01;
    glPushMatrix;
      glTranslatef(1.0,1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, Design);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;


  //Draw Sulaco Logo
  if (DemoTime > 46000) then
  begin
    glColor3f(SulacoColor,SulacoColor,SulacoColor);
    SulacoColor := SulacoColor + 0.01;
    glPushMatrix;
      glTranslatef(-1.0,-1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, Developent);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;

  // Draw Elements CD Cover
  if (DemoTime > 56000) then
  begin
    glColor3f(CDColor,CDColor,CDColor);
    CDColor := CDColor + 0.01;
    glPushMatrix;
      glTranslatef( 1.0,-1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, ElementBG);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;

  // fade out section at end of demo
    if ElapsedTime > DEMO_END-1200 then
    begin
      glActiveTextureARB(GL_TEXTURE1_ARB);
      glDisable(GL_TEXTURE_2D);
      glActiveTextureARB(GL_TEXTURE0_ARB);
      glDisable(GL_TEXTURE_2D);
      X :=0.6*(DEMO_END-ElapsedTime)/1000;
      glColor3f(X/2, X/2, X);
      glPushMatrix;
        glTranslatef( 1.0,-1.0,-3.3);

        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-10, -10, 0.0);
          glTexCoord2f(1, 0); glVertex3f( 10, -10, 0.0);
          glTexCoord2f(1, 1); glVertex3f( 10,  10, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-10,  10, 0.0);
        glEnd();
      glPopMatrix;
      glEnable(GL_TEXTURE_2D);
    end;

  if ElapsedTime > DEMO_END then
    Inc(Stage);
end;

end.
