unit StaticScreen;

interface

procedure drawStatic;
procedure drawLogoElements();

implementation

Uses dglOpenGL, Globals;

var m_ElementX  : GLfloat = 0.0;
    m_ElementY  : GLfloat = 0.0;
    m_LogoY     : GLfloat = 0.0;
    m_Rotate    : GLfloat = 0.00001;
    m_BallRotate: GLfloat = 0.0;

{------------------------------------------------------------------}
{  Draw the static and Fuzzy pulsing logo                          }
{------------------------------------------------------------------}
procedure drawStatic();
var DemoTime : Integer;    // Duration that this bit of demo has been running for.
begin

  DemoTime :=ElapsedTime - STATIC_START;
  glTranslatef(0.0, 0.0, -5);

  glColor3f(1.0,1.0,1.0);
  glEnable(GL_BLEND);
  if ((DemoTime > 100) and (DemoTime < 140)) or ((DemoTime > 800) and (DemoTime < 2840)) then
  begin
    //static
    glPushMatrix;
      glBindTexture(GL_TEXTURE_2D, Static);
      case (DemoTime MOD 200) of
        0..49 : ;  // no rotation required
        50..99 : glRotatef(90, 0, 0, 1);
        100..149 : glRotatef(180, 0, 0, 1);
        150..199 : glRotatef(270, 0, 0, 1);
      end;

      glBegin(GL_QUADS);
        glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, 3.5);
        glTexCoord2f(2.0, 0.0); glVertex3f( 1.0, -1.0, 3.5);
        glTexCoord2f(2.0, 2.0); glVertex3f( 1.0,  1.0, 3.5);
        glTexCoord2f(0.0, 2.0); glVertex3f(-1.0,  1.0, 3.5);
      glEnd;
    glPopMatrix;
    g_backRed  := 1.0;
    g_backGreen := 1.0;
  end;

  g_backRed  := g_backRed - 1.0/FPSCount*10 * g_modifier;
  g_backGreen  := g_backGreen - 1.0/FPSCount*10 * g_modifier;

  if g_backRed < 0.0 then
    g_modifier := -1;
  if g_backRed > 1.0 then
     g_modifier := 1;
  glColor3f(g_backRed,g_backGreen,g_backBlue);
  glPushMatrix;
    //draw logo
    glBindTexture(GL_TEXTURE_2D, Logo);

    glBegin(GL_QUADS);
      glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, 2.5);
      glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0, 2.5);
      glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0, 2.5);
      glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0, 2.5);
    glEnd;
    glDisable(GL_BLEND);

  glPopMatrix;

  if ElapsedTime > CD_COVER_START then
  begin
    //Count :=0;
    Inc(Stage);
  end;

end;


{------------------------------------------------------------------}
{  Draw Volition CD cover and rotating element balls               }
{------------------------------------------------------------------}
procedure drawLogoElements();
var I : integer;
begin

  glTranslatef(0.0, 0.0, -5);

  glDisable(GL_BLEND);
  glDisable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  glColor3f(1.0,1.0,1.0);
  m_BallRotate := m_BallRotate + 0.5; // Rotate all balls
  if ElapsedTime < TUNNEL_START - 3000 then
  begin

    // Background image
    glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
    glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping

    glBindTexture(GL_TEXTURE_2D, ElementBG);
    //glColor3f(g_backRed,g_backGreen,1.0);
    glBegin(GL_QUADS);
      glTexCoord2f(0, 0); glVertex3f(-1.3,-1.3, 0);
      glTexCoord2f(1, 0); glVertex3f( 1.3,-1.3, 0);
      glTexCoord2f(1, 1); glVertex3f( 1.3, 1.3, 0);
      glTexCoord2f(0, 1); glVertex3f(-1.3, 1.3, 0);
    glEnd();

    glDisable(GL_BLEND);
    //glColor3f(1.0,1.0,1.0);
    glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);

    
      //Draw fire
      glBindTexture(GL_TEXTURE_2D, Fire);
      for I :=1 to 3 do //do radial blur
      begin
        glPushMatrix;
          glDisable(GL_BLEND);
          glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
          glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
          glColor3f(1.0-I/18, 1.0-I/18, 1.0-I/18);
          glTranslatef(m_ElementX*I,0.0,0.0);
          glRotatef(m_BallRotate,0.0,1.0,0.0); // Rotate Ball
          glRotatef(90,1.0,0.0,0.0);
          gluSphere(SphereQuadratic, 0.3, 32, 32);

          glEnable(GL_BLEND);
          glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
          glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
          glDepthFunc(GL_LEQUAL);
          glBindTexture(GL_TEXTURE_2D, ReflectTex);
          glColor3f(1.0, 1.0, 1.0 );
          gluSphere(SphereQuadratic, 0.3, 32, 32);
          glDisable(GL_BLEND);
        glPopMatrix;
      end;
    


      //Draw water
      glBindTexture(GL_TEXTURE_2D, Water);
      for I :=1 to 3 do //do radial blur
      begin
        glPushMatrix;
          glDisable(GL_BLEND);
          glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
          glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
          glColor3f(1.0-I/18, 1.0-I/18, 1.0-I/18);
          glTranslatef(-m_ElementX*I,0.0,0.0);
          glRotatef(m_BallRotate,0.0,1.0,0.0); // Rotate Ball
          glRotatef(90,1.0,0.0,0.0);
          gluSphere(SphereQuadratic, 0.3, 32, 32);

          glEnable(GL_BLEND);
          glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
          glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
          glDepthFunc(GL_LEQUAL);
          glBindTexture(GL_TEXTURE_2D, ReflectTex);
          glColor4f(1.0, 1.0, 1.0 ,0.8);
          gluSphere(SphereQuadratic, 0.3, 32, 32);
          glDisable(GL_BLEND);
        glPopMatrix;
      end;

      //Draw Earth
      glBindTexture(GL_TEXTURE_2D, Earth);
      for I :=1 to 3 do //do radial blur
      begin
        glPushMatrix;
          glDisable(GL_BLEND);
          glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
          glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
          glColor3f(1.0-I/18, 1.0-I/18, 1.0-I/18);
          glTranslatef(m_ElementX*I,m_ElementY*I,0.0);
          glRotatef(m_BallRotate,0.0,1.0,0.0); // Rotate Ball
          glRotatef(90,1.0,0.0,0.0);
          gluSphere(SphereQuadratic, 0.3, 32, 32);

          glEnable(GL_BLEND);
          glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
          glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
          glDepthFunc(GL_LEQUAL);
          glBindTexture(GL_TEXTURE_2D, ReflectTex);
          glColor4f(1.0, 1.0, 1.0 ,0.8);
          gluSphere(SphereQuadratic, 0.3, 32, 32);
          glDisable(GL_BLEND);
        glPopMatrix;
      end;
    


      //Draw Wind
      glBindTexture(GL_TEXTURE_2D, Wind);
      for I :=1 to 3 do //do radial blur
      begin
        glPushMatrix;
          glDisable(GL_BLEND);
          glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
          glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
          glColor3f(1.0-I/18, 1.0-I/18, 1.0-I/18);
          glTranslatef(-m_ElementX*I,-m_ElementY*I,0.0);
          glRotatef(m_BallRotate,0.0,1.0,0.0); // Rotate Ball
          glRotatef(90,1.0,0.0,0.0);
          gluSphere(SphereQuadratic, 0.3, 32, 32);

          glEnable(GL_BLEND);
          glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
          glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
          glDepthFunc(GL_LEQUAL);
          glBindTexture(GL_TEXTURE_2D, ReflectTex);
          glColor4f(1.0, 1.0, 1.0 ,0.8);
          gluSphere(SphereQuadratic, 0.3, 32, 32);
          glDisable(GL_BLEND);
        glPopMatrix;
      end;


    glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
    glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping

    if m_ElementX < 2.0 then
    begin
      m_ElementX := m_ElementX + 0.01;
      m_ElementY := m_ElementY + 0.01;
    end;

    //draw logo
    g_backRed  := g_backRed - 1.0/FPSCount*10 * g_modifier;
    g_backGreen  := g_backGreen - 1.0/FPSCount*10 * g_modifier;

    if g_backRed < 0.0 then
      g_modifier := -1;
    if g_backRed > 1.0 then
       g_modifier := 1;

    glColor3f(g_backRed,g_backGreen,g_backBlue);
    glEnable(GL_BLEND);
    glPushMatrix;
      glBindTexture(GL_TEXTURE_2D, Logo);

      for I :=0 to 5 do //do radial blur
      begin
        glColor3f(0.6-I/18, 0.6-I/18, 0.6-I/18);

        if m_LogoY-i*0.03 < 0.0 then
        begin
          glTranslatef(0.0,m_LogoY-i*0.03,0.0);
          glBegin(GL_QUADS);
            glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, 2.5);
            glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0, 2.5);
            glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0, 2.5);
            glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0, 2.5);
          glEnd;
        end;
      end;

    glPopMatrix;

    m_LogoY := m_LogoY - 0.03;
  end
  else // Draw Balls For Rotate To Tunnel
  begin
    glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
    glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
    glRotatef(m_Rotate,0.0,0.0,1.0);
    m_Rotate := m_Rotate * 1.1;
    
    // Background image
    glBindTexture(GL_TEXTURE_2D, ElementBG);

    glBegin(GL_QUADS);
      glTexCoord2f(0, 0); glVertex3f(-1.3,-1.3, 0);
      glTexCoord2f(1, 0); glVertex3f( 1.3,-1.3, 0);
      glTexCoord2f(1, 1); glVertex3f( 1.3, 1.3, 0);
      glTexCoord2f(0, 1); glVertex3f(-1.3, 1.3, 0);
    glEnd();

    glDisable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);

    glPushMatrix;
      //Draw fire
      glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
      glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
      glBindTexture(GL_TEXTURE_2D, Fire);
      glTranslatef(2.0,0.0,0.0);
      glRotatef(m_BallRotate,0.0,1.0,0.0);
      glRotatef(90,1.0,0.0,0.0);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

      glEnable(GL_BLEND);
      glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
      glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
      glDepthFunc(GL_LEQUAL);
      glBindTexture(GL_TEXTURE_2D, ReflectTex);
      glColor4f(1.0, 1.0, 1.0 ,0.8);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

    glPopMatrix;
    
    glDisable(GL_BLEND);

    glPushMatrix;

      //Draw water
      glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
      glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
      glBindTexture(GL_TEXTURE_2D, Water);
      glTranslatef(-2.0,0.0,0.0);
      glRotatef(m_BallRotate,0.0,1.0,0.0);
      glRotatef(90,1.0,0.0,0.0);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

      glEnable(GL_BLEND);
      glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
      glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
      glDepthFunc(GL_LEQUAL);
      glBindTexture(GL_TEXTURE_2D, ReflectTex);
      glColor4f(1.0, 1.0, 1.0 ,0.8);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

    glPopMatrix;

    glDisable(GL_BLEND);

    glPushMatrix;

      //Draw Earth
      glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
      glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
      glBindTexture(GL_TEXTURE_2D, Earth);
      glTranslatef(2.0,2.0,0.0);
      glRotatef(m_BallRotate,0.0,1.0,0.0);
      glRotatef(90,1.0,0.0,0.0);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

      glEnable(GL_BLEND);
      glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
      glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
      glDepthFunc(GL_LEQUAL);
      glBindTexture(GL_TEXTURE_2D, ReflectTex);
      glColor4f(1.0, 1.0, 1.0 ,0.8);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

    glPopMatrix;

    glDisable(GL_BLEND);

    glPushMatrix;

      //Draw Wind
      glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
      glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping
      glBindTexture(GL_TEXTURE_2D, Wind);
      glTranslatef(-2.0,-2.0,0.0);
      glRotatef(m_BallRotate,0.0,1.0,0.0);
      glRotatef(90,1.0,0.0,0.0);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

      glEnable(GL_BLEND);
      glEnable(GL_TEXTURE_GEN_S);     // Enable spherical
      glEnable(GL_TEXTURE_GEN_T);     // Environment Mapping
      glDepthFunc(GL_LEQUAL);
      glBindTexture(GL_TEXTURE_2D, ReflectTex);
      glColor4f(1.0, 1.0, 1.0 ,0.8);
      gluSphere(SphereQuadratic, 0.3, 32, 32);

    glPopMatrix;

    glDisable(GL_BLEND);
    glDisable(GL_TEXTURE_GEN_S);     // Disable spherical
    glDisable(GL_TEXTURE_GEN_T);     // Disable Environment Mapping


  end;
  if ElapsedTime > TUNNEL_START then
  begin
    glBlendFunc(GL_ONE, GL_ONE);
    glDisable(GL_CULL_FACE);
    Inc(Stage);
  end;

end;

end.
