unit tentacles;

interface

Uses Globals;

  procedure drawTentacles;
  procedure initTentacles;

implementation

Uses OpenGL;

type TVertex = Record
       X, Y, Z : glFloat;
     end;
var CubeDL : glUint;
    DemoTime : Integer;
    LazerPosition : integer = 1;
    LazerSize : GLfloat = 0.05;
    LogoColor : GLfloat = 0.0;
    MysticSoundColor : GLfloat = 0.0;
    BlueSpillColor : GLfloat = 0.0;
    SulacoColor : GLfloat = 0.0;
    CDColor : GLfloat = 0.0;






{------------------------------------------------------------------}
{  Draw the tentacle scene                                         }
{------------------------------------------------------------------}
procedure drawTentacles;
var Angle, TwistAngle : glFloat;
    I : Integer;
    X : glFloat;
begin
  DemoTime :=ElapsedTime - TENTACLE_START;

  // Draw the Ocean background
  glDisable(GL_DEPTH_TEST);
  glPushMatrix();
    glTranslate(0, 0, -2.7);
    glColor3f(1.0,1.0,1.0);
    glBindTexture(GL_TEXTURE_2D, Ocean);  // Bind the Texture to the object
    glBegin(GL_QUADS);
      glTexCoord2f(0, 0); glVertex3f(-1.0, -1.0, 0.0);
      glTexCoord2f(1, 0); glVertex3f( 1.0, -1.0, 0.0);
      glTexCoord2f(1, 1); glVertex3f( 1.0,  1.0, 0.0);
      glTexCoord2f(0, 1); glVertex3f(-1.0,  1.0, 0.0);
    glEnd();
  glPopMatrix();



    
  // Draw particles
  if DemoTime < 15001 then
  begin
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);

    for I := 1 to LazerPosition do
    begin
      glPushMatrix;
        glBindTexture(GL_TEXTURE_2D, BmpParticle);
        glColor3f(1.0/LazerPosition * I,1.0/LazerPosition * I,0.0);

        glTranslatef(vLazer[I].X,vLazer[I].Y,vLazer[I].Z-4.4);
        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
          glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
          glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
        glEnd();
      glPopMatrix;
    end;

    LazerPosition := LazerPosition + 1;

    if LazerPosition > high(vLazer)-1 then
      LazerPosition := 1;

  end;
  // Draw Growing Particles
  if (DemoTime > 15000) and (DemoTime < 16001) then
  begin
    for I := 1 to High(vLazer)-1 do
    begin
      glPushMatrix;
        glBindTexture(GL_TEXTURE_2D, BmpParticle);
        glColor3f(1.0/LazerPosition * I,1.0/LazerPosition * I,0.0);

        glTranslatef(vLazer[I].X,vLazer[I].Y,vLazer[I].Z-4.4);
        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-LazerSize, -LazerSize, 0.0);
          glTexCoord2f(1, 0); glVertex3f( LazerSize, -LazerSize, 0.0);
          glTexCoord2f(1, 1); glVertex3f( LazerSize,  LazerSize, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-LazerSize,  LazerSize, 0.0);
        glEnd();
      glPopMatrix;
    end;
    LazerSize := LazerSize + 0.05;
  end;

  // Draw Blue Particles
  if DemoTime > 16000 then
  begin
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);

    for I := 1 to LazerPosition do
    begin
      glPushMatrix;
        glBindTexture(GL_TEXTURE_2D, BmpParticle);
        glColor3f(0.0,0.0,1.0/LazerPosition * I);

        glTranslatef(vLazer[I].X,vLazer[I].Y,vLazer[I].Z-4.4);
        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-0.05, -0.05, 0.0);
          glTexCoord2f(1, 0); glVertex3f( 0.05, -0.05, 0.0);
          glTexCoord2f(1, 1); glVertex3f( 0.05,  0.05, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-0.05,  0.05, 0.0);
        glEnd();
      glPopMatrix;
    end;

    LazerPosition := LazerPosition + 1;

    if LazerPosition > high(vLazer)-1 then
      LazerPosition := 1;

  end;

  // Draw Volition Logo
  if (DemoTime > 15500) then
  begin
    glPushMatrix;
      glColor3f(LogoColor,1.0,LogoColor);
      LogoColor := LogoColor + 0.01;
      glTranslatef(0.0,0.0,-4.4);
      glBindTexture(GL_TEXTURE_2D, LogoSharp);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-1.0, -1.0, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 1.0, -1.0, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 1.0,  1.0, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-1.0,  1.0, 0.0);
      glEnd();
    glPopMatrix;
  end;


  //Draw Mystic Sound Logo
  if (DemoTime > 26000) then
  begin
    glColor3f(MysticSoundColor,MysticSoundColor,MysticSoundColor);
    MysticSoundColor := MysticSoundColor + 0.01;
    glPushMatrix;
      glTranslatef(-1.0,1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, BroughtBy);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;


  //Draw BluesSpill Logo
  if (DemoTime > 36000) then
  begin
    glColor3f(BlueSpillColor,BlueSpillColor,BlueSpillColor);
    BlueSpillColor := BlueSpillColor + 0.01;
    glPushMatrix;
      glTranslatef(1.0,1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, Design);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;


  //Draw Sulaco Logo
  if (DemoTime > 46000) then
  begin
    glColor3f(SulacoColor,SulacoColor,SulacoColor);
    SulacoColor := SulacoColor + 0.01;
    glPushMatrix;
      glTranslatef(-1.0,-1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, Developent);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;

  // Draw Elements CD Cover
  if (DemoTime > 56000) then
  begin
    glColor3f(CDColor,CDColor,CDColor);
    CDColor := CDColor + 0.01;
    glPushMatrix;
      glTranslatef( 1.0,-1.0,-4.3);

      glBindTexture(GL_TEXTURE_2D, ElementBG);
      glBegin(GL_QUADS);
        glTexCoord2f(0, 0); glVertex3f(-0.5, -0.5, 0.0);
        glTexCoord2f(1, 0); glVertex3f( 0.5, -0.5, 0.0);
        glTexCoord2f(1, 1); glVertex3f( 0.5,  0.5, 0.0);
        glTexCoord2f(0, 1); glVertex3f(-0.5,  0.5, 0.0);
      glEnd();
    glPopMatrix;
  end;

  // fade out section at end of demo
    if ElapsedTime > DEMO_END-1200 then
    begin
      glDisable(GL_TEXTURE_2D);
      X :=0.6*(DEMO_END-ElapsedTime)/1000;
      glColor3f(X, X, X);
      glPushMatrix;
        glTranslatef( 1.0,-1.0,-4.3);

        glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex3f(-10, -10, 0.0);
          glTexCoord2f(1, 0); glVertex3f( 10, -10, 0.0);
          glTexCoord2f(1, 1); glVertex3f( 10,  10, 0.0);
          glTexCoord2f(0, 1); glVertex3f(-10,  10, 0.0);
        glEnd();
      glPopMatrix;
      glEnable(GL_TEXTURE_2D);
    end;

  if ElapsedTime > DEMO_END then
    Inc(Stage);
end;


{------------------------------------------------------------------}
{  Create a display list object for the tentacle cubes             }
{------------------------------------------------------------------}
procedure initTentacles;
begin
  {CubeDL :=glGenLists(1);
  glNewList(CubeDL, GL_COMPILE);
  glBegin(GL_QUADS);
    // Front Face
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0,  1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0,  1.0);
    // Back Face
    glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f(-1.0,  1.0, -1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f( 1.0,  1.0, -1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f( 1.0, -1.0, -1.0);
    // Top Face
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0, -1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0,  1.0,  1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0,  1.0,  1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0, -1.0);
    // Bottom Face
    glTexCoord2f(1.0, 1.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f( 1.0, -1.0, -1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f( 1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, -1.0,  1.0);
    // Right face
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0, -1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f( 1.0,  1.0,  1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f( 1.0, -1.0,  1.0);
    // Left Face
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f(-1.0,  1.0,  1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0, -1.0);
  glEnd();
  glEndList();}
end;

end.
